#ifndef SBW_RWLOCK_H
#define SBW_RWLOCK_H

// See linux/include/asm-x86_64/spinlock.h

#define LOCK_PREFIX \
		".section .smp_locks,\"a\"\n"	\
		"  .align 8\n"			\
		"  .quad 661f\n" /* address */	\
		".previous\n"			\
	       	"661:\n\tlock; "

#define RW_LOCK_BIAS		 0x01000000
#define RW_LOCK_BIAS_STR	 "0x01000000"

#ifndef __ASSEMBLER__

typedef struct {
	unsigned int lock;
} raw_rwlock_t;

#define __RAW_RW_LOCK_UNLOCKED		{ RW_LOCK_BIAS }

static inline void __raw_read_lock(raw_rwlock_t *rw)
{
    __asm __volatile(LOCK_PREFIX "subl $1,(%0)\n\t"
		     "jns 1f\n"
		     "call __read_lock_failed\n"
		     "1:\n"
		     ::"D" (rw), "i" (RW_LOCK_BIAS) : "memory");
}

static inline void __raw_write_lock(raw_rwlock_t *rw)
{
    __asm __volatile(LOCK_PREFIX "subl %1,(%0)\n\t"
		     "jz 1f\n"
		     "\tcall __write_lock_failed\n\t"
		     "1:\n"
		     ::"D" (rw), "i" (RW_LOCK_BIAS) : "memory");
}

static inline void __raw_read_unlock(raw_rwlock_t *rw)
{
    __asm __volatile(LOCK_PREFIX " ; incl %0" :"=m" (rw->lock) : : "memory");
}

static inline void __raw_write_unlock(raw_rwlock_t *rw)
{
    __asm __volatile(LOCK_PREFIX " ; addl $" RW_LOCK_BIAS_STR ",%0"
		     : "=m" (rw->lock) : : "memory");
}

#endif

#endif
