#ifndef __ASM_SPINLOCK_H
#define __ASM_SPINLOCK_H

#define LOCK_PREFIX \
		".section .smp_locks,\"a\"\n"	\
		"  .align 8\n"			\
		"  .quad 661f\n" /* address */	\
		".previous\n"			\
	       	"661:\n\tlock; "

typedef struct {
    volatile unsigned int slock;
} raw_spinlock_t;

static inline void __raw_spin_init(raw_spinlock_t *lock)
{
    lock->slock = 1;
}

static inline void __raw_spin_lock(raw_spinlock_t *lock)
{
    __asm __volatile("\n1:\t"
		LOCK_PREFIX " ; decl %0\n\t"
		"jns 2f\n"
		"3:\n"
		"rep;nop\n\t"
		"cmpl $0,%0\n\t"
		"jle 3b\n\t"
		"jmp 1b\n"
		"2:\t" : "=m" (lock->slock) : : "memory");
}

static inline void __raw_spin_unlock(raw_spinlock_t *lock)
{
    __asm __volatile("movl $1,%0" :"=m" (lock->slock) :: "memory");
}

#endif /* __ASM_SPINLOCK_H */
