#!/usr/bin/perl

my $max_core = 16;

sub wri()
{
    my $i;

    print "#core\t time(ms)\n";
    for ($i = 1; $i <= $max_core; $i ++) {
	system("LD_LIBRARY_PATH=$LD_LIBRARY_PATH:./obj/lib/ ./obj/wordrevidx $i");
	sleep 1;
    }
}

sub fdoper()
{
    system("./obj/fdoper");
}

sub memal()
{
    my $i;
    print "#core id\tlatency\n";
    for ($i = 0; $i < $max_core; $i++) {
        system("./obj/memal 0 $i 1");
    }
    for ($i = 0; $i < $max_core; $i++) {
        system("./obj/memal 0 $i 2");
    }
    for ($i = 0; $i < $max_core; $i++) {
        system("./obj/memal 0 $i 3");
    }
    for ($i = 0; $i < $max_core; $i++) {
        system("./obj/memal 0 $i 4");
    }
}

sub membw()
{
    print "#Memory bandwidth\n";
    system("./obj/membw");
}

sub lock()
{
    print "#cores\tcycles per op\t(linux kernel spinlock)\n";
    for ($i = 1; $i <= $max_core; $i++) {
        system("./obj/kspinlock $i");
    }
    print "#cores\tcycles per op\t(mcs lock)\n";
    for ($i = 1; $i <= $max_core; $i++) {
        system("./obj/mcslock $i");
    }
}

sub memclone() 
{
    my $i;
    print "#cores\tcycles\t# l3 miss (per page fault), Linux shared space\n";
    for ($i = 1; $i <= $max_core; $i++) {
        system("./obj/memclone $i 100 0");
    }
    print "#cores\tcycles\t# l3 miss (per page fault), Linux seperate space\n";
    for ($i = 1; $i <= $max_core; $i++) {
        system("./obj/memclone $i 100 1");
    }
}

sub mempass()
{
    my $i;
    print "#cores\tusecs\t# Linux shared space\n";
    for ($i = 1; $i <= $max_core; $i++) {
        system("./obj/mempass 0 $i");
    }
    print "#cores\tusecs\t# Linux seperate space\n";
    for ($i = 1; $i <= $max_core; $i++) {
        system("./obj/mempass 1 $i");
    }

}

my $bench = shift;
if ($bench eq undef) {
    print "usage: run.pl benchmark\n";
    print "benchmark choices:\n";
    print " all        - run all benchmarks\n";
    print " fdoper     - file descriptors (Figure 1)\n";
    print " memal      - memory access latency (Figure 2)\n";
    print " membw      - memory bandwidth (Figure 2)\n";
    print " lock       - lock operations (Figure 3)\n";
    print " memclone   - soft page faults (Figure 7a)\n";
    print " mempass    - soft page faults (Figure 7b)\n";
    print " wordrevidx - MapReduce (Figure 10)\n";
}

if ($bench eq "all" || $bench eq "fdoper") {
    fdoper();
    print "\n";
}
if ($bench eq "all" || $bench eq "memal") {
    memal();
    print "\n";
}
if ($bench eq "all" || $bench eq "membw") {
    membw();
    print "\n";
}
if ($bench eq "all" || $bench eq "lock") {
    lock();
    print "\n";
}
if ($bench eq "all" || $bench eq "memclone") {
    memclone();
    print "\n";
}
if ($bench eq "all" || $bench eq "mempass") {
    mempass();
    print "\n";
}
if ($bench eq "all" || $bench eq "wri") {
    wri();
    print "\n";
}

